#ifndef ATL_dtGetNB_geqrf

/*
 * NB selection for GEQRF: Side='RIGHT', Uplo='UPPER'
 * M : 25,96,120,144,192,384,768,1512,3000
 * N : 25,96,120,144,192,384,768,1512,3000
 * NB : 9,9,9,36,28,24,24,48,72
 */
#define ATL_dtGetNB_geqrf(n_, nb_) \
{ \
   if ((n_) < 132) (nb_) = 9; \
   else if ((n_) < 168) (nb_) = 36; \
   else if ((n_) < 288) (nb_) = 28; \
   else if ((n_) < 1140) (nb_) = 24; \
   else if ((n_) < 2256) (nb_) = 48; \
   else (nb_) = 72; \
}


#endif    /* end ifndef ATL_dtGetNB_geqrf */
